#ifndef INCLUDED_COM_SUN_STAR_BEANS_PROPERTYVALUE_HPP
#define INCLUDED_COM_SUN_STAR_BEANS_PROPERTYVALUE_HPP

#include "sal/config.h"

#include "com/sun/star/beans/PropertyValue.hdl"

#include "com/sun/star/beans/PropertyState.hpp"
#include "com/sun/star/uno/Any.hxx"
#include "com/sun/star/uno/Type.hxx"
#include "cppu/unotype.hxx"
#include "osl/mutex.hxx"
#include "rtl/ustring.h"
#include "rtl/ustring.hxx"
#include "rtl/instance.hxx"
#include "sal/types.h"
#include "typelib/typeclass.h"
#include "typelib/typedescription.h"

namespace com { namespace sun { namespace star { namespace beans {

inline PropertyValue::PropertyValue() SAL_THROW(())
    : Name()
    , Handle(0)
    , Value()
    , State(::com::sun::star::beans::PropertyState_DIRECT_VALUE)
{
}

inline PropertyValue::PropertyValue(const ::rtl::OUString& Name_, const ::sal_Int32& Handle_, const ::com::sun::star::uno::Any& Value_, const ::com::sun::star::beans::PropertyState& State_) SAL_THROW(())
    : Name(Name_)
    , Handle(Handle_)
    , Value(Value_)
    , State(State_)
{
}

} } } }

namespace com { namespace sun { namespace star { namespace beans { namespace detail {

struct thePropertyValueType : public rtl::StaticWithInit< ::com::sun::star::uno::Type *, thePropertyValueType >
{
    ::com::sun::star::uno::Type * operator()() const
    {
        ::rtl::OUString the_name(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.beans.PropertyValue"));
        ::rtl::OUString the_tname0(RTL_CONSTASCII_USTRINGPARAM("string"));
        ::rtl::OUString the_name0(RTL_CONSTASCII_USTRINGPARAM("Name"));
        ::rtl::OUString the_tname1(RTL_CONSTASCII_USTRINGPARAM("long"));
        ::rtl::OUString the_name1(RTL_CONSTASCII_USTRINGPARAM("Handle"));
        ::rtl::OUString the_tname2(RTL_CONSTASCII_USTRINGPARAM("any"));
        ::rtl::OUString the_name2(RTL_CONSTASCII_USTRINGPARAM("Value"));
        ::cppu::UnoType< ::com::sun::star::beans::PropertyState >::get();
        ::rtl::OUString the_tname3(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.beans.PropertyState"));
        ::rtl::OUString the_name3(RTL_CONSTASCII_USTRINGPARAM("State"));
        ::typelib_StructMember_Init the_members[] = {
            { { typelib_TypeClass_STRING, the_tname0.pData, the_name0.pData }, false },
            { { typelib_TypeClass_LONG, the_tname1.pData, the_name1.pData }, false },
            { { typelib_TypeClass_ANY, the_tname2.pData, the_name2.pData }, false },
            { { typelib_TypeClass_ENUM, the_tname3.pData, the_name3.pData }, false } };
        ::typelib_TypeDescription * the_newType = 0;
        ::typelib_typedescription_newStruct(&the_newType, the_name.pData, 0, 4, the_members);
        ::typelib_typedescription_register(&the_newType);
        ::typelib_typedescription_release(the_newType);
        return new ::com::sun::star::uno::Type(::com::sun::star::uno::TypeClass_STRUCT, the_name); // leaked
    }
};
} } } } }

namespace com { namespace sun { namespace star { namespace beans {

inline ::com::sun::star::uno::Type const & cppu_detail_getUnoType(SAL_UNUSED_PARAMETER ::com::sun::star::beans::PropertyValue const *) {
    return *detail::thePropertyValueType::get();
}

} } } }

inline ::com::sun::star::uno::Type const & SAL_CALL getCppuType(SAL_UNUSED_PARAMETER ::com::sun::star::beans::PropertyValue const *) SAL_THROW(()) {
    return ::cppu::UnoType< ::com::sun::star::beans::PropertyValue >::get();
}

#endif // INCLUDED_COM_SUN_STAR_BEANS_PROPERTYVALUE_HPP
